;+
;Function: igp_test
;
;Purpose:  Tests whether the idl/geopack module is installed
;          Provides installation message if not installed
;
;Keywords:
;         None
;
;Returns: 1 on success 0 on failure
;
;Example:
;   if(igp_test() eq 0) then return
;Notes:
;  Should be called in all idl geopack wrapper routines
;
; $LastChangedBy: pcruce $
; $LastChangedDate: 2007-10-05 12:06:54 -0700 (Fri, 05 Oct 2007) $
; $LastChangedRevision: 1670 $
; $URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/idl_socware/trunk/external/IDL_GEOPACK/igp_test.pro $
;-

function igp_test

help, /dlm, output = out

filter = strfilter(out, '*GEOPACK*')

if(size(filter, /n_dim) eq 0 && filter[0] eq '') then begin
  message, /continue, 'Required module IDL/GEOPACK not installed'
  message, /continue, 'To install geopack please download a copy'
  message, /continue, 'Place the module binary and the .dlm in:'
  message, /continue, !DLM_PATH
  message, /continue, 'and restart IDL to install the package'
  message, /continue, 'more detailed installation instructions'
  message, /continue, 'can be found on the Themis web site, or'
  message, /continue, 'in the Themis software distribution at'
  message, /continue, 'external/IDL_GEOPACK/README.txt'
  return, 0
endif

return, 1
  
end
