;+
;VERSION:
;  $LastChangedBy: bckerr $
;  $LastChangedDate: 2008-01-04 15:56:27 -0800 (Fri, 04 Jan 2008) $
;  $LastChangedRevision: 2228 $
;  $URL: svn+ssh://thmsvn@ambrosia.ssl.berkeley.edu/repos/thmsoc/trunk/idl/themis/spacecraft/particles/SST/thm_sst_psif.pro $
;-

function thm_sst_psif,time,index=index,probe=probe,times=times,nomask=nomask


data_cache,'th'+probe+'_sst_raw_data',data,/get

if not keyword_set(data) then begin
   dprint,dlevel=0,'No data loaded for ',probe
   return,0
endif

if keyword_set(times) then return, *data.sif_064_time

dptr = data.sif_064_data
dim = size(/dimension,*dptr)
dist = thm_sst_dist3d_16x64(/ion)
dist.project_name = 'THEMIS'
dist.data_name = 'SST Ion Full distribution'
dist.magf = !values.f_nan

if n_elements(index) eq 0 then begin
    if n_elements(time) eq 0 then begin
       ctime,time
    endif
    index=round( interp(dindgen(dim[0]),*data.sif_064_time,time) )
endif
dprint,dlevel=5,index
dist.index = index
if index lt 0 or index ge n_elements(*data.sif_064_time) then return,dist
dist.time = (*data.sif_064_time)[index]
dist.end_time = dist.time+3
dist.data= thm_part_decomp16((*data.sif_064_data)[index,*,*])
dist.cnfg= (*data.sif_064_cnfg)[index]
dist.nspins= (*data.sif_064_nspins)[index]
;dist.cnfg= (*data.sif_064_hed)[index,13]
dist.atten = (*data.sif_064_atten)[index]
dist.units_name = 'Counts'
dist.valid=1
dist.mass = 1836.*0.511e6/(2.9979e5)^2
dist.bins[12:15,*] = 0
if ~ keyword_set(nomask) then begin
   bad_ang = [0,16,32,48]
   ;dist.bins[*,bad_ang]=0
   dist.bins[*,bad_ang]=!values.f_nan
endif

return,dist
end
