;+
;  $Id: thm_sst_psir.pro 2339 2008-02-04 19:48:56Z davin-win $
;-
function thm_sst_psir,time,index=index,probe=probe,times=times


data_cache,'th'+probe+'_sst_raw_data',data,/get

if not keyword_set(data) then begin
   dprint,dlevel=0,'No data loaded for ',probe
   return,0
endif

if keyword_set(times) then return, *data.sir_001_time

dptr = data.sir_001_data
dim = size(/dimension,*dptr)
dist = thm_sst_dist3d_16x1(/ion)
dist.project_name = 'THEMIS'
dist.data_name  = 'SST Ion Reduced Distribution'
dist.magf = !values.f_nan

if n_elements(index) eq 0 then begin
    if n_elements(time) eq 0 then   ctime,time,npoints=1
    index=round( interp(dindgen(dim[0]),*data.sir_mix_time,time) )
endif

dprint,dlevel=3,index

dist.index = index
dist.time = (*data.sir_001_time)[index]
dist.end_time = dist.time+3
dist.data= thm_part_decomp16((*data.sir_001_data)[index,*,*])
dist.cnfg= (*data.sir_001_cnfg)[index]
dist.nspins= (*data.sir_001_nspins)[index]
;dist.cnfg= (*data.sir_001_hed)[index,13]
dist.atten = (*data.sir_001_atten)[index]
dist.units_name = 'Counts'
dist.valid=1
dist.mass = 1836.*0.511e6/(2.9979e5)^2

return,dist
end
